Subject: Re: [PATCH v7 2/3] Documentation: alias: add notes on shell expansion

From: Junio C Hamano <[email-masked]>
Date: Mon, 27 May 2024 10:48:37 -0700

Ian Wienand <[email-masked]> writes:

> When writing inline shell for shell-expansion aliases (i.e. prefixed
> with "!"), there are some caveats around argument parsing to be aware
> of.  This series of notes attempts to explain what is happening more
> clearly.
>
> Signed-off-by: Ian Wienand <[email-masked]>
> ---
>  Documentation/config/alias.txt | 14 ++++++++++++++
>  1 file changed, 14 insertions(+)

This one has become much shorter but very much to the point.  

Let's further do "appended via `"$@"`" -> "added at the end".  The
example given in that bullet point would be easier to understand
that way.

Will queue.

> diff --git a/Documentation/config/alias.txt b/Documentation/config/alias.txt
> index 40851ef429..75f9f5e26f 100644
> --- a/Documentation/config/alias.txt
> +++ b/Documentation/config/alias.txt
> @@ -27,3 +27,17 @@ it will be treated as a shell command.  For example, defining
>    repository, which may not necessarily be the current directory.
>  * `GIT_PREFIX` is set as returned by running `git rev-parse --show-prefix`
>    from the original current directory. See linkgit:git-rev-parse[1].
> +* Shell command aliases always receive any extra arguments provided to
> +  the Git command-line as positional arguments.
> +** Care should be taken if your shell alias is a "one-liner" script
> +   with multiple commands (e.g. in a pipeline), references multiple
> +   arguments, or is otherwise not able to handle positional arguments
> +   appended via `"$@"`.  For example: `alias.cmd = "!echo $1 | grep
> +   $2"` called as `git cmd 1 2` will be executed as 'echo $1 | grep $2
> +   1 2', which is not what you want.
> +** A convenient way to deal with this is to write your script
> +   operations in an inline function that is then called with any
> +   arguments from the command-line.  For example `alias.cmd = "!c() {
> +   echo $1 | grep $2 ; }; c" will correctly execute the prior example.
> +** Setting `GIT_TRACE=1` can help you debug the command being run for
> +   your alias.